# Patterns for SEIM Event-B models

## Contributors

Jean-Paul Bodeveix, Arnaud Dieumegard, Mamoun Filali

## Content

This project contains the Event-B models for the formalization of pattern instantiations on system engineering models.

### Structure

![Pattern instantiation and application model](event-b_model_structure2.jpg "Pattern instantiation and application project structure")

### Documentation

Documentation on the content of these models is provided on the deliverable.

### Additional elements

An other context is provided: pattern_safety. 
This model contains the first version of an instance of pattern directly encoded using Event-B.
Using simulation tools such as Pro-B on this model may produce an instance of Model where the pattern is instantiated. This shall be checked as it is only a prototype.